#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "prem_main") {&prem_main;}
if ($q->param('fct') eq "save_premium_info") {&save_premium_info;}



##################################################################################

sub prem_main
{


$hbox = acs::get_heading_box("$web_url/ic_premium.gif", "Premium Link Manager", qq[

<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="99%" class="normaltext">The Premium Link Manager enables you to set and manage aspects of your premium links.</td>
    <td width="1%"><a href="$admin_url/help.cgi?fct=premium_mngr" target="_blank"><img src="$web_url/bhelps.gif" border="0"></a></td>
  </tr>
</table>
]); 


$hbox2 = acs::get_heading_box("$web_url/ic_dirm.gif", "Premium Link Settings & Premium Links:", qq[
 <ul class="normaltext">
    <li><strong><a href="$admin_url/admin66.cgi">Browse/Edit Premium Links </a><br>
    </strong>This section enables you to view/delete/edit/move/copy premium links.<br>
    <br>
     </li>
    <li><strong><a href="$admin_url/admin23.cgi">Premium Link Settings </a><br>
    </strong>This section allows you to set the amount of days a link will be considered as a   premium link. It also allows you to enter the URL to your order form that users will use   to pay you for premium listings.
    Also comes with other configurable Premium Link Options.</li>
  </ul>
]); 


$hbox3 = acs::get_heading_box("$web_url/ic_email4.gif", "Premium Link Email Functions:", qq[
 <ul class="normaltext">
    <li><strong><a href="$admin_url/admin65.cgi">Send Email To Premium Link Owners </a><br>
    </strong>Choose this option to send email to premium link owners.<br>
    <br>
     </li>
    <li><strong><a href="$admin_url/admin25.cgi">Email Retrieval </a><br>
    </strong>Enables you to retrieve email addresses of premium links to use third party   mailing software.</li>
  </ul>
]); 


$hbox4 = acs::get_heading_box("$web_url/ic_email3.gif", "Email Customization:", qq[

<ul class="normaltext">
    <li><strong><a href="$admin_url/admin24.cgi?fct=edit_welcome">Welcome Email </a><br>
    </strong>This email is sent when a premium submission takes place. It almost acts like an   autoresponder, because it is sent just after a user added a premium listing/link via the   'premium add url' form. This is optional and you can disable this by <strong><a href="$admin_url/admin23.cgi" target="_blank">clicking here</a>.</strong><br>
    <br>
     </li>
    <li><strong><a href="$admin_url/admin24.cgi?fct=edit_newsub_accept">New Premium: Submission   Acceptance Email </a><br>
    </strong>This email is sent to a user when his new premium submission has been approved   for inclusion into the directory.<br>
    <br>
    </li>
    <li><strong><a href="$admin_url/admin24.cgi?fct=edit_submissionreject">New Premium Submission   Rejection Email </a><br>
    </strong>This email is sent to a user when his new premium submission has not been   approved for inclusion into the directory. This might be due to non-payment or other   reasons.<br>
     <br>
     </li>
    <li><strong><a href="$admin_url/admin24.cgi?fct=edit_submissioninform">New Premium Submission   Informer Email </a><br>
    </strong>This email is sent to you, to inform you that a new premium submission has been   made. This is optional and you can be disabled by <a href="$admin_url/admin23.cgi"><strong>clicking   here. </strong></a><br>
     <br>
     </li>
    <li><strong><a href="$admin_url/admin24.cgi?fct=expiry_emails">Expiry Emails </a><br>
    </strong>These emails are sent out to premium link owners when premium links are about to   expire or when premium links expired. <strong>(Note that you have to use a CRON program to   send out emails. See the manual for more on this) </strong></li>
  </ul>
]); 


print <<END_OF_PS;
<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox
$hbox2
$hbox3
$hbox4
</body>
</html>
END_OF_PS

}



sub save_premium_info
{

$order_url = $q->param('premium_orderform_url');

if ($order_url eq "$web_url/sample_orderf.html"){$order_url = "";}

open (PRM, "> $data_dir/prem.cfg");
 print PRM $order_url . "\n";
 print PRM $q->param('premium_expire_days') . "\n";
 print PRM $q->param('welcome_email') . "\n";
 print PRM $q->param('premium_submission_inform') . "\n";
 
 print PRM $q->param('month_exp') . "\n";
 print PRM $q->param('week_exp') . "\n";
 print PRM $q->param('exp') . "\n";
 print PRM $q->param('standard_orderform_url') . "\n";
 
close (PRM);



$hbox = acs::get_heading_box("$web_url/ic_settings3.gif", "Settings Saved", qq[
<a href="$admin_url/admin23.cgi?fct=prem_main">Click Here to Continue</a>
]); 




print <<END_OF_PRM;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox
</body>
</html>

END_OF_PRM

}





sub start
{

$approve_email = acs::get_file_contents("$data_dir/prem.cfg");
@pconfig = split (/\n/, $approve_email);

if ($pconfig[0] eq "") {$pconfig[0] = "$web_url/sample_orderf.html";}

if ($pconfig[2] eq "Yes")
	{
	$welcome_email_yes = "selected";
	}
	else
	{
	$welcome_email_no = "selected";
	}



if ($pconfig[3] eq "Yes")
	{
	$premium_submission_inform_yes = "selected";
	}
	else
	{
	$premium_submission_inform_no = "selected";
	}


if ($pconfig[4] eq "Yes") ### ONE MONTH EXPIRY
	{
	$month_exp_yes = "selected";
	}
	else
	{
	$month_exp_no = "selected";
	}


if ($pconfig[5] eq "Yes") ### ONE WEEK EXPIRY
	{
	$week_exp_yes = "selected";
	}
	else
	{
	$week_exp_no = "selected";
	}


if ($pconfig[6] eq "Yes") ### EXPIRED
	{
	$exp_yes = "selected";
	}
	else
	{
	$exp_no = "selected";
	}



$hbox = acs::get_heading_box("$web_url/ic_settings3.gif", "Premium Link Settings", qq[

<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="88%" valign="top" class="normaltext">Here you can supply the link to your order processors order
    form when someone wants to purchase and add a premium listing. See the help section below
    for a better explanation. <BR>
    <a href="$admin_url/admin23.cgi?fct=prem_main"><b>Go Back</b></a>
    
    </td>
    <td width="6%" valign="top" align="right"><a href="$admin_url/help.cgi?fct=prem_settings"
    target="_blank"><strong><img src="$web_url/bhelps.gif" border="0"> </strong></a></td>
  </tr>
</table>
]); 

$helpb = acs::quick_help("Help:",qq[

<p><strong>Premium URL: Submission Basics </strong><br>
Users will have to click on the 'Add Premium Listing' link from your directory/search
engine to submit premium listings. Once clicked they will be taken to the new submission
form, just as if they clicked the normal 'add url' link from your directory/search engine.
After completing the 'new submission' form to submit their new listing, they will be
redirected to a payment form. </p>

<p><strong>Payment Forms / Order Processors </strong><br>
After adding a new premium listing the users will be redirected to the URL (Payment Form)
you supply above to pay for their premium listing. The URL above could be a link to your
order processors payment form that has been set up by you, like PayPal, WorldPay, etc...
To receive credit card payment from users wanting to add a premium listing you could have
an account from PayPal, WorldPay, etc... Set up an order form with them and have users
redirected after adding/submitting their premium listing so that they can pay for the
listing. The premium links/listings that has been added are always listed first in the
'new submissions' section in the control panel. Premium submitted submissions is also
indicated. </p>

<p><strong>Processing a Premium URL <br>
</strong>So let's say you received a premium submission and the user has paid for his
submission. At the side of your order processor you can see that someone has paid you X
amount for a premium listing. To locate the premium listing that has been submitted you
will need to look in the 'New Submissions' section when in the control panel. To go to the
'New Submissions' section in the control panel, log into the control panel. Then click the
'Dir Manager' button. On your left there will be a link called 'New Submissions'. Click
this link. You will see new submissions. The Premium submissions are always listed first
and indicated. Match the name of the order that you received for your new submission with
the name that has been recorded when an order has been placed via your order processor. </p>

<p>Now you know by whom the premium URL has been paid for and which link/listing needs to
be approved for display as a premium listing. Approve the premium URL for display. See the
online documentation of PowerSeek for more on this. </p>

<p><strong>Premium Listing Notes</strong><br>
When a premium URL is submitted it is recorded as a premium URL submission. Once you have
received payment for it, you can just approve it from the 'new submissions' section and it
will be available as a premium URL.
</p>

]); 


print <<END_OF_PRM;

<html>

<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>

<body>

$hbox

<form method="POST" action="$admin_url/admin23.cgi">
  <input type="hidden" name="fct" value="save_premium_info"><table border="0"
  cellpadding="6" width="100%" style="border: 1px solid rgb(218,218,218)" height="404"
  cellspacing="1">
    <tr>
      <td width="101%" height="15" colspan="2" valign="top" class="normaltext"
      background="$web_url/bar6.gif"><strong>Premium URL Settings</strong></td>
    </tr>
    <tr>
      <td width="41%" height="25" valign="top" class="normaltext">Premium Link Order Form URL:
      (URL to your order processor) </td>
      <td width="60%" height="25" valign="top" class="normaltext"><input type="text"
      name="premium_orderform_url" size="50" value="$pconfig[0]"> </td>
    </tr>
    <tr>
      <td width="41%" height="25" valign="top" class="normaltext">If you would like to sell
      standard listings as well then provide the Order Form URL for standard listings here: </td>
      <td width="60%" height="25" valign="top" class="normaltext"><input type="text"
      name="standard_orderform_url" size="50" value="$pconfig[7]"> <br>
      (Leave blank if you don't intend to charge a fee for standard links) </td>
    </tr>
    <tr>
      <td width="41%" height="51" valign="top" class="normaltext">For how many days is a premium
      URL/Listing valid? </td>
      <td width="60%" height="51" valign="top" class="normaltext"><input type="text"
      name="premium_expire_days" size="6" value="$pconfig[1]"> <strong>Days <br>
      </strong>When the link is older than this number of days, it will not be available as a
      premium listing anymore and only show as an ordinary link/listing. </td>
    </tr>
    <tr>
      <td width="41%" height="28" valign="top" class="normaltext">Would you like a 'Welcome
      Email' to be sent to users when they submit a premium URL? </td>
      <td width="60%" height="28" valign="top" class="normaltext"><select name="welcome_email"
      size="1">
        <option $welcome_email_yes value="Yes"> Yes </option>
        <option $welcome_email_no value="No"> No </option>
      </select> </td>
    </tr>
    <tr>
      <td width="41%" height="26" valign="top" class="normaltext">Would you like to be informed
      via email when a Premium URL is submitted? </td>
      <td width="60%" height="26" valign="top" class="normaltext"><select
      name="premium_submission_inform" size="1">
        <option $premium_submission_inform_yes value="Yes"> Yes </option>
        <option $premium_submission_inform_no value="No"> No </option>
      </select> </td>
    </tr>
    <tr>
      <td width="41%" height="28" valign="top" class="normaltext">Would you like to send an
      email to premium link owners that their there link will expire in one month: </td>
      <td width="60%" height="28" valign="top" class="normaltext"><select name="month_exp"
      size="1">
        <option $month_exp_yes value="Yes"> Yes </option>
        <option $month_exp_no value="No"> No </option>
      </select> <br>
      This email can be customized when in the Control Panel &gt;&gt; Plugins &gt;&gt; Premium
      Link Manager &gt;&gt; Expiry Emails <br>
      <strong>(Note that you have to use a CRON program to send out emails. See the manual for
      more on this) </strong></td>
    </tr>
    <tr>
      <td width="41%" height="28" valign="top" class="normaltext">Would you like to send an
      email to premium link owners that their there link will expire in one week: </td>
      <td width="60%" height="28" valign="top" class="normaltext"><select name="week_exp"
      size="1">
        <option $week_exp_yes value="Yes"> Yes </option>
        <option $week_exp_no value="No"> No </option>
      </select> <br>
      This email can be customized when in the Control Panel &gt;&gt; Plugins &gt;&gt; Premium
      Link Manager &gt;&gt; Expiry Emails <br>
      <strong>(Note that you have to use a CRON program to send out emails. See the manual for
      more on this) </strong></td>
    </tr>
    <tr>
      <td width="41%" height="14" valign="top" class="normaltext">Would you like to send an
      email to premium link owners that their there link has expired: </td>
      <td width="60%" height="14" valign="top" class="normaltext"><select name="exp" size="1">
        <option $exp_yes value="Yes"> Yes </option>
        <option $exp_no value="No"> No </option>
      </select> <br>
      This email can be customized when in the Control Panel &gt;&gt; Plugins &gt;&gt; Premium
      Link Manager &gt;&gt; Expiry Emails <br>
      <strong>(Note that you have to use a CRON program to send out emails. See the manual for
      more on this) </strong></td>
    </tr>
    <tr>
      <td width="41%" height="27" valign="top" class="normaltext"></td>
      <td width="60%" height="27" valign="top" class="normaltext"><input type="submit"
      value="    Save    " name="B1"> </td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>


$helpb



</body>
</html>
END_OF_PRM

}


####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

